/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#ifndef JSInspectorBackend_h
#define JSInspectorBackend_h

#if ENABLE(INSPECTOR)

#include "JSDOMBinding.h"
#include <runtime/JSGlobalObject.h>
#include <runtime/JSObjectWithGlobalObject.h>
#include <runtime/ObjectPrototype.h>

namespace WebCore {

class InspectorBackend;

class JSInspectorBackend : public DOMObjectWithGlobalPointer {
    typedef DOMObjectWithGlobalPointer Base;
public:
    JSInspectorBackend(NonNullPassRefPtr<JSC::Structure>, JSDOMGlobalObject*, PassRefPtr<InspectorBackend>);
    virtual ~JSInspectorBackend();
    static JSC::JSObject* createPrototype(JSC::ExecState*, JSC::JSGlobalObject*);
    virtual bool getOwnPropertySlot(JSC::ExecState*, const JSC::Identifier& propertyName, JSC::PropertySlot&);
    virtual bool getOwnPropertyDescriptor(JSC::ExecState*, const JSC::Identifier& propertyName, JSC::PropertyDescriptor&);
    virtual const JSC::ClassInfo* classInfo() const { return &s_info; }
    static const JSC::ClassInfo s_info;

    static PassRefPtr<JSC::Structure> createStructure(JSC::JSValue prototype)
    {
        return JSC::Structure::create(prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), AnonymousSlotCount);
    }

    static JSC::JSValue getConstructor(JSC::ExecState*, JSC::JSGlobalObject*);
    InspectorBackend* impl() const { return m_impl.get(); }

private:
    RefPtr<InspectorBackend> m_impl;
protected:
    static const unsigned StructureFlags = JSC::OverridesGetOwnPropertySlot | Base::StructureFlags;
};

JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject*, InspectorBackend*);
InspectorBackend* toInspectorBackend(JSC::JSValue);

class JSInspectorBackendPrototype : public JSC::JSObjectWithGlobalObject {
    typedef JSC::JSObjectWithGlobalObject Base;
public:
    static JSC::JSObject* self(JSC::ExecState*, JSC::JSGlobalObject*);
    virtual const JSC::ClassInfo* classInfo() const { return &s_info; }
    static const JSC::ClassInfo s_info;
    virtual bool getOwnPropertySlot(JSC::ExecState*, const JSC::Identifier&, JSC::PropertySlot&);
    virtual bool getOwnPropertyDescriptor(JSC::ExecState*, const JSC::Identifier&, JSC::PropertyDescriptor&);
    static PassRefPtr<JSC::Structure> createStructure(JSC::JSValue prototype)
    {
        return JSC::Structure::create(prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), AnonymousSlotCount);
    }
    JSInspectorBackendPrototype(JSC::JSGlobalObject* globalObject, NonNullPassRefPtr<JSC::Structure> structure) : JSC::JSObjectWithGlobalObject(globalObject, structure) { }
protected:
    static const unsigned StructureFlags = JSC::OverridesGetOwnPropertySlot | Base::StructureFlags;
};

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionStoreLastActivePanel(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionSaveApplicationSettings(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionSaveSessionSettings(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionEnableSearchingForNode(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionDisableSearchingForNode(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionEnableMonitoringXHR(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionDisableMonitoringXHR(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionEnableResourceTracking(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionDisableResourceTracking(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionGetResourceContent(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionReloadPage(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionStartTimelineProfiler(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionStopTimelineProfiler(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionEnableDebugger(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionDisableDebugger(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionSetBreakpoint(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionRemoveBreakpoint(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionActivateBreakpoints(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionDeactivateBreakpoints(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionPause(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionResume(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionStepOverStatement(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionStepIntoStatement(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionStepOutOfFunction(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionSetPauseOnExceptionsState(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionEditScriptSource(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionGetScriptSource(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionEnableProfiler(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionDisableProfiler(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionStartProfiling(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionStopProfiling(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionGetProfileHeaders(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionGetProfile(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionRemoveProfile(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionClearProfiles(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionTakeHeapSnapshot(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionSetInjectedScriptSource(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionDispatchOnInjectedScript(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionAddScriptToEvaluateOnLoad(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionRemoveAllScriptsToEvaluateOnLoad(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionGetChildNodes(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionSetAttribute(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionRemoveAttribute(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionSetTextNodeValue(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionGetEventListenersForNode(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionCopyNode(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionRemoveNode(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionChangeTagName(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionGetOuterHTML(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionSetOuterHTML(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionAddInspectedNode(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionPerformSearch(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionSearchCanceled(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionPushNodeByPathToFrontend(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionClearConsoleMessages(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionHighlightDOMNode(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionHideDOMNodeHighlight(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionGetStyles(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionGetAllStyles(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionGetInlineStyle(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionGetComputedStyle(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionGetStyleSheet(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionGetRuleRangesForStyleSheetId(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionApplyStyleText(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionSetStyleText(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionSetStyleProperty(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionToggleStyleEnabled(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionSetRuleSelector(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionAddRule(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionGetCookies(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionDeleteCookie(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionGetApplicationCaches(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionReleaseWrapperObjectGroup(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionDidEvaluateForTestInFrontend(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionGetDatabaseTableNames(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionGetDOMStorageEntries(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionSetDOMStorageItem(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsInspectorBackendPrototypeFunctionRemoveDOMStorageItem(JSC::ExecState*);
// Attributes

JSC::JSValue jsInspectorBackendConstructor(JSC::ExecState*, JSC::JSValue, const JSC::Identifier&);

} // namespace WebCore

#endif // ENABLE(INSPECTOR)

#endif
